<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="90px">
      <el-form-item label="类型名称" prop="complaintTypeName">
        <el-input
          v-model="queryParams.complaintTypeName"
          placeholder="请输入投诉类型名称"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
	    <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['course:userCourseComplaintType:add']"
        >新增</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table
      v-loading="loading"
      :data="userCourseComplaintTypeList"
      row-key="complaintTypeId"
      default-expand-all
      :tree-props="{children: 'children', hasChildren: 'hasChildren'}"
    >
<!--      <el-table-column label="父id，关联主键id" prop="parentId" />-->
      <el-table-column label="投诉类型名称" align="center" prop="complaintTypeName" />
      <el-table-column label="级别" align="center" prop="typeLevel" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['course:userCourseComplaintType:edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-plus"
            @click="handleAdd(scope.row)"
            v-hasPermi="['course:userCourseComplaintType:add']"
            v-if="scope.row.typeLevel === 1"
          >新增</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['course:userCourseComplaintType:remove']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <!-- 添加或修改看课投诉类型对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="600px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="100px">
        <el-form-item label="上级类型" prop="parentId">
          <treeselect
            v-model="form.parentId"
            :options="userCourseComplaintTypeOptions"
            :normalizer="normalizer"
            :disabled="true"
            placeholder="请选择上级类型" />
        </el-form-item>
        <el-form-item label="当前类型名称" prop="complaintTypeName">
          <el-input v-model="form.complaintTypeName" placeholder="请输入投诉类型名称" />
        </el-form-item>
<!--        <el-form-item label="级别" prop="typeLevel">-->
<!--          <el-input v-model="form.typeLevel" placeholder="请输入级别" />-->
<!--        </el-form-item>-->
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listUserCourseComplaintType, getUserCourseComplaintType, delUserCourseComplaintType, addUserCourseComplaintType, updateUserCourseComplaintType, exportUserCourseComplaintType } from "@/api/course/userCourseComplaintType";
import Treeselect from "@riophae/vue-treeselect";
import "@riophae/vue-treeselect/dist/vue-treeselect.css";

export default {
  name: "UserCourseComplaintType",
  components: {
    Treeselect
  },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 显示搜索条件
      showSearch: true,
      // 看课投诉类型表格数据
      userCourseComplaintTypeList: [],
      // 看课投诉类型树选项
      userCourseComplaintTypeOptions: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        parentId: null,
        complaintTypeName: null,
        typeLevel: null,
        isDel: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
      }
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询看课投诉类型列表 */
    getList() {
      this.loading = true;
      listUserCourseComplaintType(this.queryParams).then(response => {
        this.userCourseComplaintTypeList = this.handleTree(response.data, "complaintTypeId", "parentId");
        this.loading = false;
      });
    },
    /** 转换看课投诉类型数据结构 */
    normalizer(node) {
      if (node.children && !node.children.length) {
        delete node.children;
      }
      return {
        id: node.complaintTypeId,
        label: node.complaintTypeName,
        children: node.children
      };
    },
	/** 查询看课投诉类型下拉树结构 */
    getTreeselect() {
      listUserCourseComplaintType().then(response => {
        this.userCourseComplaintTypeOptions = [];
        const data = { complaintTypeId: 0, complaintTypeName: '顶级节点', children: [] };
        data.children = this.handleTree(response.data, "complaintTypeId", "parentId");
        this.userCourseComplaintTypeOptions.push(data);
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        complaintTypeId: null,
        parentId: null,
        complaintTypeName: null,
        typeLevel: null,
        isDel: null,
        createTime: null,
        updateTime: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    /** 新增按钮操作 */
    handleAdd(row) {
      this.reset();
      this.getTreeselect();
      if (row != null && row.complaintTypeId) {
        this.form.parentId = row.complaintTypeId;
        this.form.typeLevel = 2;
      } else {
        this.form.parentId = 0;
        this.form.typeLevel = 1;
      }
      this.open = true;
      this.title = "添加看课投诉类型";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      this.getTreeselect();
      if (row != null) {
        this.form.parentId = row.complaintTypeId;
      }
      getUserCourseComplaintType(row.complaintTypeId).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改看课投诉类型";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.complaintTypeId != null) {
            updateUserCourseComplaintType(this.form).then(response => {
              this.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addUserCourseComplaintType(this.form).then(response => {
              this.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      // 收集要删除的所有ID（包括子级）
      const complaintTypeIds = this.collectAllIds(row);
      this.$confirm(`是否确认删除当前行数据及其子级？`, "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(() => {
          return delUserCourseComplaintType(complaintTypeIds);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        }).catch(() => {});
    },
    /** 递归收集所有子级ID */
    collectAllIds(node) {
      const ids = [node.complaintTypeId];

      if (node.children && node.children.length > 0) {
        node.children.forEach(child => {
          ids.push(...this.collectAllIds(child));
        });
      }

      return ids;
    }
  }
};
</script>
